# zbot/drivers//console.py
#
#

""" console bot. """

## IMPORTS

from zbot.defines import BOLD, ENDC, YELLOW
from zbot.log import datefmt
from zbot import Bot, Object, kernel

import logging
import time
import sys
import os

## CONSOLE

class ConsoleBot(Bot):

    def _raw(zelf, txt):
        try: sys.stdout.write(txt) ; sys.stdout.flush()
        except Exception as ex: logging.warn(str(ex))

    def say(zelf, *args, **kwargs):
        try: txt = args[1]
        except IndexError: txt = args[0]
        if zelf.outer: o = zelf.outer ; o.write(txt) ; o.write("\n") ; o.flush()
        else: zelf._raw("%s\n" % txt)

    def get_prompt(zelf, *args, **kwargs): return "%s -=- %s%s<%s " % (time.strftime(datefmt), BOLD, YELLOW, ENDC)

    def get_one(zelf, *args, **kwargs):
        import readline
        o = Object()
        if not kernel.cfg.do_shell: o.txt =  " ".join(kernel.cfg.runargs) ; o._state = "once"
        else: o.txt = input(zelf.get_prompt())
        o._target = zelf
        return o
