# zbot/plugs/find.py
#
#

""" output a set of objects. """

## IMPORTS

from zbot.utils import error, time_string, to_time, time_stamp, do_objects, format_obj, short_date
from zbot import kernel

import logging
import re

## do_find command

daylist = ["Date", "ctime", "path"]

def do_find(event):
    opts = event.opts
    args = event.args
    knobs = event.knobs
    if "mdate" not in args: args.insert(0, "mdate")
    else: args.extend(list(opts.keys()))
    done = []
    objs = []
    for obj in do_objects(event):
        try:
            obj.mdate = short_date(obj.Date)
            if not obj.mdate: obj.mdate = to_time(obj.added)
        except: error()
        value = None
        go = True
        for arg in args:
            try: value = getattr(obj, arg)
            except AttributeError: continue
            if not value: continue
        if go: objs.append(obj)
    for obj in sorted(objs, key=lambda x: x.mdate):
        txt = ""
        for arg in args:
            try: txt += "%s -=- " % obj[arg]
            except KeyError: continue
        if not txt: continue
        txt = txt[:-5]
        if "text" in opts:
            for line in obj.text.splitlines():
                if opts["text"] in line: event.reply("%s -=- %s" % (txt, line)) ; break
        else: event.reply(txt)        
        if "u" in knobs:
            if txt not in done: done.append(txt)
        else: done.append(txt)
    #for txt in sorted(done): event.reply(txt)

kernel.cmnds.register("find", do_find)
